<?php
/**
 * Show BBCode to guests (sbto)
 *
 * @package sbto
 * @author emanuele
 * @copyright 2011 emanuele, Simple Machines
 * @license http://www.simplemachines.org/about/smf/license.php BSD
 *
 * @version 0.1.7
 */

if (!defined('SMF'))
	die('Hacking attempt...');

function show_bbcode_to_guests(&$codes)
{
	global $modSettings, $user_info, $txt;
	if(isset($modSettings['hiddenBBC']))
		$hiddenBBC = explode(',', $modSettings['hiddenBBC']);

	$no_beforeafter_tags = array('abbr', 'acronym', 'anchor', 'email', 'ftp', 'iurl', 'list', 'table', 'tr', 'url');

	foreach ($codes as &$code)
	{
		if(isset($hiddenBBC) && in_array($code['tag'], $hiddenBBC) && $user_info['is_guest'])
		{
			$code['type'] = isset($code['type']) ? $code['type'] : 'unparsed_content';
			$warning_text = '<div class="sbtog_hide_tag">' . $txt['mod_not_allowed_see'] . ' ' . $txt['login_or_register'] . '</div>';

			switch ($code['type'])
			{
				case 'unparsed_equals':
				case 'unparsed_equals_content':
				case 'parsed_equals':
					$code['type'] = 'unparsed_equals_content';
					break;
				case 'unparsed_content':
				case 'closed':
					$code['type'] = $code['type'];
					break;
				case 'unparsed_commas':
				case 'unparsed_commas_content':
					$code['type'] = 'unparsed_commas_content';
					break;
			}

			if (isset($code['validate']) && !in_array($code['tag'], $no_beforeafter_tags))
				$code['validate'] = create_function('&$tag, &$data, $disabled', '
					$data = \'' . $warning_text . '\';
				');
			elseif (empty($code['before']) || empty($code['after']) || (isset($code['type']) && $code['type'] == 'closed') || in_array($code['tag'], $no_beforeafter_tags))
			{
				unset($code['before']);
				unset($code['after']);
				unset($code['validate']);
				$code['content'] = $warning_text;
			}
			else
				$code['content'] = $code['before'] . $warning_text . $code['after'];

			unset($code['test']);
			unset($code['disabled_content']);
			unset($code['disabled_before']);
			unset($code['disabled_after']);
			unset($code['block_level']);
			unset($code['trim']);
			unset($code['quoted']);
			unset($code['require_parents']);
			unset($code['require_children']);
			unset($code['disallow_children']);
			unset($code['parsed_tags_allowed']);
		}
	}
}

function show_bbcode_to_guests_checkHookOrder(&$admin_areas)
{
	global $modSettings;

	$hookFunctionName = 'show_bbcode_to_guests';
	$hookName = 'integrate_bbc_codes';

	if (!empty($modSettings[$hookName]))
	{
		if(strpos($modSettings[$hookName], $hookFunctionName) == (strlen($modSettings[$hookName])-strlen($hookFunctionName)))
			return;

		$hooks = explode(',',$modSettings[$hookName]);
		$key = array_search($hookFunctionName, $hooks);

		unset($hooks[$key]);

		$hooks[] = $hookFunctionName;
		updateSettings(array($hookName => implode(',', $hooks)));
	}
}
?>